import { ethers, providers } from 'ethers';
import type { Log } from '@ethersproject/abstract-provider';
import type { ReadWriteChannel } from '@cerc-io/ts-channel';
export declare class EthClient {
    provider: providers.BaseProvider;
    constructor(provider: providers.BaseProvider);
    static dial(chainUrl: string): EthClient;
    transactionByHash(transactionHash: string): Promise<providers.TransactionResponse>;
    chainID(): Promise<bigint>;
    subscribeFilterLogs(query: ethers.providers.EventType, ch: ReadWriteChannel<Log>): () => void;
    subscribeNewHead(ch: ReadWriteChannel<number>): () => void;
    subscribeError(ch: ReadWriteChannel<Error>): () => void;
}
